﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

//追加
using System.IO;
using System.Data.SqlServerCe;

namespace ideatimecapsule_cs
{
    //データベースユーティリティ
    public class DBUtility
    {
        //データベースのファイル名
        private const string DATABASE_FILENAME = "idea.sdf";

        //データベースの接続文字列
        private const string CONNECTION_STRING = "Data Source = 'idea.sdf'; LCID=1033; Password = strongpassword; Encrypt = TRUE;";

        //テーブル作成のSQL
        private const string COMMANDTEXT_CREATE_TABLE_IDEA = @"CREATE TABLE IDEA(
    IDEA_ID BIGINT PRIMARY KEY IDENTITY(1,1) NOT NULL,
    LIMIT_TIME DATETIME NOT NULL,
    IDEA_CONTENTS NVARCHAR(2000) NOT NULL
)";
        //コンストラクタは非公開
        private DBUtility()
        {
        }

        //データベースの初期化
        public static void InitializeDB()
        {
            //DBファイルが存在する場合は何もしない
            if (File.Exists(DATABASE_FILENAME))
                return;

            //DBを作成する
            SqlCeEngine engine = new SqlCeEngine(CONNECTION_STRING);
            engine.CreateDatabase();

            //コネクションを作成して開く
            using (SqlCeConnection con = GetConnection())
            {
                con.Open();

                //テーブルを作成する
                SqlCeCommand command = new SqlCeCommand(COMMANDTEXT_CREATE_TABLE_IDEA, con);
                command.ExecuteNonQuery();

                //コネクションを閉じる
                con.Close();
            }
        }

        //コネクションを作成する
        public static SqlCeConnection GetConnection()
        {
            return new SqlCeConnection(CONNECTION_STRING);
        }

    }
}
